#include "AfterImageP.h"

/*===========================================================================*/
/* Фμ                                                              */
/*===========================================================================*/

int AfterImages_GetNumber(AfterImages after_images)
{
  if (ObjList_IsStart(after_images->list, after_images->current))
    return (after_images->first_number);
  return (after_images->second_number);
}

XArc * AfterImages_GetArcs(AfterImages after_images)
{
  if (ObjList_IsStart(after_images->list, after_images->current))
    return (after_images->first_arcs);
  return (after_images->second_arcs);
}

/*===========================================================================*/
/* ֥ȤȺ                                                  */
/*===========================================================================*/

AfterImages AfterImages_Create(int size, int number,
			       double * x, double * y,
			       int * change_flags,
			       int x_min, int y_min, int x_max, int y_max,
			       ObjList list)
{
  AfterImages after_images;
  int i, first_number, second_number;

  after_images = (AfterImages)malloc(sizeof(_AfterImages));
  if (after_images == NULL)
    Error("AfterImages_Create", "Cannot allocate memory");

  after_images->first_arcs = (XArc *)malloc(sizeof(XArc) * number);
  if (after_images->first_arcs == NULL)
    Error("AfterImages_Create", "Cannot allocate memory");

  after_images->second_arcs = (XArc *)malloc(sizeof(XArc) * number);
  if (after_images->second_arcs == NULL)
    Error("AfterImages_Create", "Cannot allocate memory");

  first_number = second_number = 0;
  for (i = 0; i < number; i++) {

    if ((x[i] < x_min) || (x[i] > x_max) || (y[i] > y_max)) {
      continue;
    }

    after_images->first_arcs[first_number].x = x[i] - size / 2;
    after_images->first_arcs[first_number].y = y[i] - size / 2;
    after_images->first_arcs[first_number].width  = size;
    after_images->first_arcs[first_number].height = size;
    after_images->first_arcs[first_number].angle1 = 0;
    after_images->first_arcs[first_number].angle2 = 360*64;
    first_number++;

    if (change_flags[i] == 0) continue;

    after_images->second_arcs[second_number].x = x[i] - size / 2;
    after_images->second_arcs[second_number].y = y[i] - size / 2;
    after_images->second_arcs[second_number].width  = size;
    after_images->second_arcs[second_number].height = size;
    after_images->second_arcs[second_number].angle1 = 0;
    after_images->second_arcs[second_number].angle2 = 360*64;
    second_number++;
  }

  after_images->first_number = first_number;
  after_images->second_number = second_number;
  after_images->list = list;
  after_images->current = ObjList_GetStart(after_images->list);

  return (after_images);
}

AfterImages AfterImages_Destroy(AfterImages after_images)
{
  if (!after_images) return (NULL);

  if (after_images->first_arcs) free(after_images->first_arcs);
  if (after_images->second_arcs) free(after_images->second_arcs);

  free(after_images);

  return (NULL);
}

/*===========================================================================*/
/* ߤοͤGC֤(Ǹˤ NULL ֤)                            */
/*===========================================================================*/

GC AfterImages_GetGC(AfterImages after_images)
{
  ColorGC color_gc;
  GC gc;

  if (after_images->current == NULL) return (NULL);
  if (ObjList_IsEndEdge(after_images->list, after_images->current))
    return (NULL);

  color_gc = (ColorGC)ObjListData_GetObj(after_images->current);
  gc =  ColorGC_GetGC(color_gc);

  return (gc);
}

/*===========================================================================*/
/* current ˿ʤ롥                                                */
/*===========================================================================*/

void AfterImages_MoveNext(AfterImages after_images)
{
  after_images->current = ObjListData_GetNext(after_images->current);
}

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
