#include "XHanabi.h"
#include "arguments.h"

#ifndef XHANABI_DIRECTRY
#define XHANABI_DIRECTRY "/usr/X11R6/lib/X11/XHanabi"
#endif

#ifndef STUDYING_FLAG
#define STUDYING_FLAG 0
#endif

#ifndef CACHE_FLAG
#define CACHE_FLAG 1
#endif

#ifndef CACHE_SIZE
#define CACHE_SIZE 30
#endif

#ifndef HASH_NUMBER
#define HASH_NUMBER 1024
#endif

#ifndef TAMA_MAX_NUMBER
#define TAMA_MAX_NUMBER 100
#endif

#ifndef DEFAULT_FINE
#define DEFAULT_FINE 100
#endif

#ifndef DEFAULT_WAIT
#define DEFAULT_WAIT 0
#endif

static char * display_name = ":0.0";
static char * background_color = "black";
static char * filename = "xhanabi.conf";
static int wait_time = DEFAULT_WAIT;
static int studying_flag = STUDYING_FLAG;
static int cache_flag = CACHE_FLAG;
static int cache_size = CACHE_SIZE;
static int hash_number = HASH_NUMBER;
static int tama_max_number = TAMA_MAX_NUMBER;
static int fine = DEFAULT_FINE;

void help()
{
  printf("XHanabi\n");
  exit (0);
}

Argument arguments[] = {
  {"-h",                ARGUMENTS_FUNCTION, &help},
  {"-help",             ARGUMENTS_FUNCTION, &help},
  {"-display",          ARGUMENTS_STRING,   &display_name},
  {"-bg",               ARGUMENTS_STRING,   &background_color},
  {"-background",       ARGUMENTS_STRING,   &background_color},
  {"-background-color", ARGUMENTS_STRING,   &background_color},
  {"-f",                ARGUMENTS_STRING,   &filename},
  {"-file",             ARGUMENTS_STRING,   &filename},
  {"-wait",             ARGUMENTS_INTEGER,  &wait_time},
  {"-fine",             ARGUMENTS_INTEGER,  &fine},
  {"-tama-max-number",  ARGUMENTS_INTEGER,  &tama_max_number},

  /* ʲϥ塼˥ѤαץǤ */

  /* ؽǽѤˤϡʲͭˤޤ                      */
  /* ؽǽȥåʻѤǤޤʻѤƤ⤢ޤ̣Ϥޤ*/
  /* ؽǽѤȡ instance ꥹȤƬ˻ä          */
  /* 褦ˤʤޤϤǹ®                                  */
  /* ؽǽ̵ȡ򥽡ȤƳǼΤǡȤˡ        */
  /* ǼƤʤäФˡ˸Ǥڤ뤳ȤǤ褦*/
  /* ʤޤϤǹ®                                            */
  {"-studying",         ARGUMENTS_FLAG_ON,  &studying_flag},
  {"-no-studying",      ARGUMENTS_FLAG_OFF, &studying_flag},

  /* ʲͭˤȡåѤ褦ˤʤޤ */

  {"-cache",            ARGUMENTS_FLAG_ON,  &cache_flag},
  {"-no-cache",         ARGUMENTS_FLAG_OFF, &cache_flag},

  /* åΥꤷޤ */
  {"-cache-size",       ARGUMENTS_INTEGER,  &cache_size},

  /* ϥåΥꤷޤ */
  {"-hash-number",      ARGUMENTS_INTEGER,  &hash_number},

  {NULL,                ARGUMENTS_NONE,     NULL}
};

int main(int argc, char * argv[])
{
  XHanabi xhanabi;

  Arguments_Read(&argc, argv, arguments);
  if (fine <= 0) fine = 100;

  xhanabi = XHanabi_Create(display_name, background_color,
			   XHANABI_DIRECTRY, filename,
			   studying_flag, cache_flag, cache_size, hash_number,
			   fine);
  XHanabi_Start(xhanabi, tama_max_number, wait_time);
  XHanabi_Destroy(xhanabi);

  return (0);
}
